<template>
  <GenericLayout>
    <template #header>
      <Header
        back-button
        :title="pageTitle"
        :badge-content="pageSubTitle"
      />
    </template>
    <template #page-content>
      <template v-if="isDesktopPlatform">
        <div
          class="page-title"
          v-if="pageTitle"
        >
          {{ pageTitle }}
        </div>
        <div
          class="page-subtitle"
          v-if="pageSubTitle"
        >
          {{ pageSubTitle }}
        </div>
      </template>

      <template v-if="loading">
        <div
          class="column flex-center"
        >
          <q-spinner-dots
            color="primary"
            size="24px"
          />
        </div>
      </template>

      <template v-else-if="constraint && plot">
        <q-card :square="!isDesktopPlatform">
          <PlotConstraintItem :constraint="constraint" />

          <PlotConstraintMap
            :plot="plot"
            :constraint="constraint"
            :map-style="'height: 400px'"
          />
        </q-card>
      </template>

      <template v-else>
        <q-card :square="!isDesktopPlatform">
          <q-card-section>
            <span
              class="text-subtitle1 text-dark"
            >
              <translate>No constraint found</translate>
            </span>
          </q-card-section>
        </q-card>
      </template>
    </template>
    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import PlotConstraintMixin from 'src/pages/holding-campaign/plot/mixins/PlotConstraintMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import PlotConstraintMap from 'src/pages/holding-campaign/plot/components/PlotConstraintMap'
import PlotConstraintItem from 'src/pages/holding-campaign/plot/components/PlotConstraintItem'
import queryConstraintByPk from 'src/pages/holding-campaign/plot/graphql/queryConstraintByPk'
import queryPlotByPk from 'src/pages/holding-campaign/plot/graphql/queryPlotByPk'

export default {
  name: 'PlotConstraintPage',
  mixins: [
    PlatformMixin,
    PlotConstraintMixin
  ],
  components: {
    GenericLayout,
    Header,
    Footer,
    PlotConstraintMap,
    PlotConstraintItem
  },
  computed: {
    pageTitle () {
      return this.constraintName
    },
    pageSubTitle () {
      return this.$store.state.fastplatform.holdingCampaign.campaign.name
    },
    loading () {
      return (!this.constraint && this.$apollo.queries.constraint.loading) || (!this.plot && this.$apollo.queries.plot.loading)
    },
    constraintName () {
      if (this.constraint && this.plot) {
        return this.$gettextInterpolate(this.$gettext('Constraint on %{plotName}'), { plotName: this.plot.name })
      } else {
        return '...'
      }
    },
    constraintId () {
      return this.$route.params.constraintId
    }
  },
  apollo: {
    constraint: {
      query: queryConstraintByPk,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          constraintId: Number(this.constraintId)
        }
      }
    },
    plot: {
      query: queryPlotByPk,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          plotId: this.constraint.plotId
        }
      },
      skip () {
        return this.constraint?.plotId === undefined || this.constraint?.plotId === null
      }
    }
  }
}
</script>
